Attribute VB_Name = "ChargerMachine"
Option Explicit

Public Fichier_Machine As String ' fichier dat machine ( definition machine )
Public Indice_Machine As String  ' indice machine du fichier ini
Public Fichier_Ini As String ' Fichier Tripod_simul.ini ( declaration des machines)

Public Declare Sub SetWindowPos Lib "User32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

'INI File Functions
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As String, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As Any, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long

' Les Outils
'Public Outil() As Outil
' Les portes Outils
'Public POOutil() As PO_Outil'' Definition de diffrent porte-outil

Sub Init_PO(Fichier_Def As String, POutil() As PO_Outil)
Dim I As Integer
Dim J As Integer
Dim NB_outil As Integer
Dim Section_outil As String
Dim Indice_point As String
Dim TabPt

NB_outil = Val(mfncGetFromIni("Machine", "Nb_Outil", Fichier_Def))

For I = 1 To NB_outil
    Section_outil = "Porte_Outil" & I
    POutil(I).Nom = Val(mfncGetFromIni(Section_outil, "Nom", Fichier_Def))
    POutil(I).Remarque = Val(mfncGetFromIni(Section_outil, "Remarque", Fichier_Def))
    
    POutil(I).NB_point = Val(mfncGetFromIni(Section_outil, "NB_Point", Fichier_Def))
    POutil(I).Origine.Z = Val(mfncGetFromIni(Section_outil, "OrigineZ", Fichier_Def))
    POutil(I).Dec_Z = Val(mfncGetFromIni(Section_outil, "Dec_Z", Fichier_Def))
    ReDim POutil(I).Coord(POutil(I).NB_point)
    
    For J = 1 To POutil(I).NB_point
        Indice_point = "P" & J
        TabPt = Split(mfncGetFromIni(Section_outil, Indice_point, Fichier_Def), ",")
        With POutil(I)
            .Coord(J).X = Val(TabPt(0))
            .Coord(J).Y = Val(TabPt(1))
        End With
    Next J
Next I


End Sub
'def plan control
Sub Def_Plan(Zgrille As Double)
    Dim P1 As Point3
    
    P1.X = -1000
    P1.Y = -1000
    P1.Z = Val(Zgrille)
    
    Ta1.S(0) = P1
    Ta1.S(1) = P1
    Ta1.S(2) = P1
    
    Ta1.S(1).X = -P1.X
    Ta1.S(2).Y = -P1.Y
    
    Ta2 = Ta1
    
    Ta2.S(0).X = -P1.X
    Ta2.S(0).Y = -P1.Y
End Sub

'Decode une instruction de mouvement pour une macro machine ( exemple chargement outil)
'
' On retrouve les axes machines et pour chaques axes
'   # veut dire ne change pas la valeur de l'axe = Valeur de l'axe donne par Pos
'   C reprend la valeur original avant la macro ( point d'usinage ) donne par Pos_SVG
'   Autre Indique la nouvelle valeur de l'axe'
'
Sub Decode_Mvt(Chaine As String, Pos As position, Pos_SVG As position)
Dim TabSplt
Dim I As Integer

TabSplt = Split(Chaine, ",")

For I = 0 To UBound(TabSplt)
    Select Case TabSplt(I)
    
    Case "#"
    
    Case "C"
        Pos.Join(I + 1) = Pos_SVG.Join(I + 1)
    Case Else
        Pos.Join(I + 1) = Val(TabSplt(I))
    End Select
Next I

End Sub

Sub init_outil(Fichier_Def As String, Outl() As Outil)
Dim I As Integer
Dim NB_outil As Integer
Dim Section_outil As String


NB_outil = Val(mfncGetFromIni("Machine", "Nb_Outil", Fichier_Def))

With TRIPOD_SIMUL_FRM
If .TreeViewTOOL.Nodes.Count > 1 Then
        .TreeViewTOOL.Nodes.Clear
        .TreeViewTOOL.Nodes.Add , tvwLast, "LIB", NB_outil & " Outil(s)", 1, 1

    Else
        .TreeViewTOOL.Nodes(1).Text = NB_outil & " Outil(s)"
        .TreeViewTOOL.Nodes(1).Expanded = True
End If
.TreeViewTOOL.Nodes(1).Expanded = True
.TreeViewTOOL.Nodes(1).Bold = True  'gras

' Type outil
'   Type = 1  ' Boule
'   Type = 2  ' Torique
'   Type = 3  ' Foret
For I = 1 To NB_outil
    Section_outil = "Outil" & I
    Outl(I).Type = Val(mfncGetFromIni(Section_outil, "Type", Fichier_Def))
    Outl(I).Nom = Val(mfncGetFromIni(Section_outil, "Nom", Fichier_Def))
    Outl(I).Remarque = Val(mfncGetFromIni(Section_outil, "Remarque", Fichier_Def))
    
    Outl(I).Diametre = Val(mfncGetFromIni(Section_outil, "Diametre", Fichier_Def))
    Outl(I).RayonCoin = Val(mfncGetFromIni(Section_outil, "RayonCoin", Fichier_Def))
    Outl(I).LG = Val(mfncGetFromIni(Section_outil, "LG", Fichier_Def))
    Outl(I).LG_Coupe = Val(mfncGetFromIni(Section_outil, "LG_Coupe", Fichier_Def))
    Outl(I).LgCone = Val(mfncGetFromIni(Section_outil, "LgCone", Fichier_Def))   ' pour foret
    Outl(I).DiametreCorp = Val(mfncGetFromIni(Section_outil, "DiametreCorp", Fichier_Def))
        
        
    .TreeViewTOOL.Nodes.Add "LIB", tvwChild, Section_outil, Generation_nom_outil(Outl(I), I), Outl(I).Type + 1, Outl(I).Type + 1
    
    
    ' case des emplacements vide dans le magasin
    If Outl(I).Type = 0 Then
        .TreeViewTOOL.Nodes(I + 1).Bold = True 'gras
        .TreeViewTOOL.Nodes(I + 1).BackColor = &HFFC0C0 'bleu cyan  ' &HFF& ' Rouge
    End If
    
Next I

End With

End Sub
'Gnration de nom suivant infos outil
Function Generation_nom_outil(Outl_courant As Outil, Num As Integer) As String
Dim Name As String

Name = "T" & Num & "  "

If Outl_courant.Nom <> "0" Then
          If Outl_courant.Type = 0 Then
            Name = "Emplacement Vide"
          Else
            Name = Name & Outl_courant.Nom
          End If
Else
            ' Type outil
            '   Type = 1  ' Boule
            '   Type = 2  ' Torique
            '   Type = 3  ' Foret
            Select Case Outl_courant.Type
             Case 0
                Name = "Emplacement Vide"
             Case 1
                Name = Name & "FB" & Outl_courant.Diametre
            
             Case 2
                Name = Name & "FT" & Outl_courant.Diametre & "R" & Outl_courant.RayonCoin
                
             Case 3
                Name = Name & "Foret " & Outl_courant.Diametre
                
            Case Else
                
                
            End Select
End If

Generation_nom_outil = Name
End Function
Public Sub Charger_Machine(Fichier_Def As String, Mach As Machine3D)
Dim NBElement As Integer
Dim I As Integer
Dim J As Integer
Dim Val_Ch As String
Dim SectionElement As String
Dim Color As Long

'
NBElement = Val(mfncGetFromIni("Machine", "Element", Fichier_Def))
ReDim Mach.Element(NBElement)

' Affichage depart
xm_base = Val(mfncGetFromIni("Machine", "Xm_base", Fichier_Def))
ym_base = Val(mfncGetFromIni("Machine", "Ym_base", Fichier_Def))
zm_base = Val(mfncGetFromIni("Machine", "Zm_base", Fichier_Def))
    
Zoom_base = Val(mfncGetFromIni("Machine", "Zoom_base", Fichier_Def))
    
PosX_base = Val(mfncGetFromIni("Machine", "PosX_base", Fichier_Def))
PosY_base = Val(mfncGetFromIni("Machine", "PosY_base", Fichier_Def))

Color = Val(mfncGetFromIni("Machine", "Couleur_Piece", Fichier_Def)) ' recuperation couleur piece
If Color = 0 Then Color = 33023 ' init couleur orange pour piece
Piece.Color = GetRVB(Color)

xm = xm_base
ym = ym_base
zm = zm_base
Zoom = Zoom_base
PosX = PosX_base
PosY = PosY_base

'Grille base
GrilleX = Val(mfncGetFromIni("Machine", "GrilleX", Fichier_Def))
If GrilleX = 0 Then GrilleX = 50
GrilleY = Val(mfncGetFromIni("Machine", "GrilleY", Fichier_Def))
If GrilleY = 0 Then GrilleY = 50
PasGrille = Val(mfncGetFromIni("Machine", "PasGrille", Fichier_Def))
If PasGrille = 0 Then PasGrille = 20
    
    
Mach.Nom = mfncGetFromIni("Machine", "Nom", Fichier_Def)
Mach.Type = Val(mfncGetFromIni("Machine", "Type", Fichier_Def))
Mach.NB_axe = Val(mfncGetFromIni("Machine", "NB_axe", Fichier_Def))
Mach.Element_Fixe = Val(mfncGetFromIni("Machine", "Element_Fixe", Fichier_Def))
Mach.Element_Collision = Val(mfncGetFromIni("Machine", "Element_Collision", Fichier_Def))
Mach.Element_Tripode = Val(mfncGetFromIni("Machine", "Element_Tripode", Fichier_Def))
Mach.Element_Principaux = Val(mfncGetFromIni("Machine", "Element_Principaux", Fichier_Def))
Mach.Pos0.X = Val(mfncGetFromIni("Machine", "Position0_X", Fichier_Def))
Mach.Pos0.Y = Val(mfncGetFromIni("Machine", "Position0_Y", Fichier_Def))
Mach.Pos0.Z = Val(mfncGetFromIni("Machine", "Position0_Z", Fichier_Def))
Mach.Or0.X = Val(mfncGetFromIni("Machine", "Orientation0_X", Fichier_Def))
Mach.Or0.Y = Val(mfncGetFromIni("Machine", "Orientation0_Y", Fichier_Def))
Mach.Or0.Z = Val(mfncGetFromIni("Machine", "Orientation0_Z", Fichier_Def))

' Reinit objet
'Type_axe = 0 => Translation
'Type_axe = 1 => rotation
For I = 0 To NBElement
    'Nom de la section
    SectionElement = "Element" & I
       
    Mach.Element(I).Name = mfncGetFromIni(SectionElement, "Nom", Fichier_Def)
    Mach.Element(I).fichier = mfncGetFromIni(SectionElement, "Fichier", Fichier_Def)

    Mach.Element(I).Color = GetRVB(QBColor(Val(mfncGetFromIni(SectionElement, "Couleur", Fichier_Def))))
    Mach.Element(I).Element_Associe = Val(mfncGetFromIni(SectionElement, "Element_Associe", Fichier_Def))
    ReDim Mach.Element(I).EA(Mach.Element(I).Element_Associe)
    For J = 1 To Mach.Element(I).Element_Associe
        Mach.Element(I).EA(J) = Val(mfncGetFromIni(SectionElement, "Element_V" & J, Fichier_Def))
    Next J
    
    Mach.Element(I).MiniAxe = Val(mfncGetFromIni(SectionElement, "Mini_axe", Fichier_Def))
    Mach.Element(I).MaxiAxe = Val(mfncGetFromIni(SectionElement, "Maxi_axe", Fichier_Def))
    
    Mach.Element(I).Type_axe = Val(mfncGetFromIni(SectionElement, "Type_axe", Fichier_Def))
    Mach.Element(I).Origine.X = Val(mfncGetFromIni(SectionElement, "Origine_X", Fichier_Def))
    Mach.Element(I).Origine.Y = Val(mfncGetFromIni(SectionElement, "Origine_Y", Fichier_Def))
    Mach.Element(I).Origine.Z = Val(mfncGetFromIni(SectionElement, "Origine_Z", Fichier_Def))
    Mach.Element(I).Vecteur.X = Val(mfncGetFromIni(SectionElement, "Vecteur_X", Fichier_Def))
    Mach.Element(I).Vecteur.Y = Val(mfncGetFromIni(SectionElement, "Vecteur_Y", Fichier_Def))
    Mach.Element(I).Vecteur.Z = Val(mfncGetFromIni(SectionElement, "Vecteur_Z", Fichier_Def))
    If I = Mach.Element_Tripode Then
        ReDim Mach.Element(I).Pt_Tripode(3)
        For J = 1 To 3
             Val_Ch = "Tripode" & J & "_X"
            Mach.Element(I).Pt_Tripode(J).X = Val(mfncGetFromIni(SectionElement, Val_Ch, Fichier_Def))
            Val_Ch = "Tripode" & J & "_Y"
            Mach.Element(I).Pt_Tripode(J).Y = Val(mfncGetFromIni(SectionElement, Val_Ch, Fichier_Def))
            Val_Ch = "Tripode" & J & "_Z"
            Mach.Element(I).Pt_Tripode(J).Z = Val(mfncGetFromIni(SectionElement, Val_Ch, Fichier_Def))
        Next J
    End If
    
Next I



'Magasin porte outil
Mach.PositionMagasin = Val(mfncGetFromIni("Magasin", "PositionMagasin", Fichier_Def))
Mach.MagasinPo.MiniAxe = Val(mfncGetFromIni("Magasin", "Mini_axe", Fichier_Def))
Mach.MagasinPo.MaxiAxe = Val(mfncGetFromIni("Magasin", "Maxi_axe", Fichier_Def))
    
'Magasin outil
If Mach.PositionMagasin Then
    Mach.MagasinPo.Name = mfncGetFromIni("Magasin", "Nom", Fichier_Def)
    Mach.MagasinPo.fichier = mfncGetFromIni("Magasin", "Fichier", Fichier_Def)
    Mach.MagasinPo.Color = GetRVB(QBColor(Val(mfncGetFromIni("Magasin", "Couleur", Fichier_Def))))
    Mach.MagasinPo.Type_axe = Val(mfncGetFromIni("Magasin", "Type_axe", Fichier_Def))
    Mach.MagasinPo.Origine.X = Val(mfncGetFromIni("Magasin", "Origine_X", Fichier_Def))
    Mach.MagasinPo.Origine.Y = Val(mfncGetFromIni("Magasin", "Origine_Y", Fichier_Def))
    Mach.MagasinPo.Origine.Z = Val(mfncGetFromIni("Magasin", "Origine_Z", Fichier_Def))
    Mach.MagasinPo.Vecteur.X = Val(mfncGetFromIni("Magasin", "Vecteur_X", Fichier_Def))
    Mach.MagasinPo.Vecteur.Y = Val(mfncGetFromIni("Magasin", "Vecteur_Y", Fichier_Def))
    Mach.MagasinPo.Vecteur.Z = Val(mfncGetFromIni("Magasin", "Vecteur_Z", Fichier_Def))
End If

End Sub


'****************************************************************
' Name: .INI read/write routines
' Description:.INI read/write routines
'mfncGetFromIni-- Reads from an *.INI file strFileName(full path & file name)
'mfncWriteIni--Writes to an *.INI file called strFileName (full path & file name)
'****************************************************************
Function mfncGetFromIni(strSectionHeader As String, strVariableName As String, strFileName As String) As String
       '*** DESCRIPTION:Reads from an *.INI file strFileName (fullpath & file name)
       '     '*** RETURNS:The string stored in [strSectionHeader], line  beginning strVariableName=
       '     '*** NOTE: Requires declaration of API call GetPrivateProfileString
       '     'Initialise variable
       Dim strReturn As String
       '     'Blank the return string
       strReturn = String(255, Chr(0))
       '     'Get requested information, trimming the returned string
       mfncGetFromIni = Left$(strReturn, GetPrivateProfileString(strSectionHeader, ByVal strVariableName, "", strReturn, Len(strReturn), strFileName))
End Function
Function mfncWriteIni(strSectionHeader As String, strVariableName As String, strValue As String, strFileName As String) As Integer
       '*** DESCRIPTION:Writes to an *.INI file called strFileName
       '     (full       path & file name)
       '*** RETURNS:Integer indicating failure (0) or success (other)       to write
       '     '*** NOTE: Requires declaration of API call     WritePrivateProfileString
       '     'Call the API
       mfncWriteIni = WritePrivateProfileString(strSectionHeader, strVariableName, strValue, strFileName)
End Function
Function mfncDeleteIniKey(strSectionHeader As String, strVariableName As String, strFileName As String) As Integer
       '*** DESCRIPTION:Writes to an *.INI file called strFileName
       '     (full       path & file name)
       '*** RETURNS:Integer indicating failure (0) or success (other)       to write
       '     '*** NOTE: Requires declaration of API call     WritePrivateProfileString
       '     'Call the API
       mfncDeleteIniKey = WritePrivateProfileString(strSectionHeader, strVariableName, 0&, strFileName)
End Function
Function mfncDeleteIniSection(strSectionHeader As String, strFileName As String) As Integer
       '*** DESCRIPTION:Writes to an *.INI file called strFileName
       '     (full       path & file name)
       '*** RETURNS:Integer indicating failure (0) or success (other)       to write
       '     '*** NOTE: Requires declaration of API call     WritePrivateProfileString
       '     'Call the API
       mfncDeleteIniSection = WritePrivateProfileString(strSectionHeader, 0&, 0&, strFileName)
End Function
Public Function GetIniInt(strSectionHeader As String, Key As String, strFileName As String, Optional Default As Long) As Long
    GetIniInt = GetPrivateProfileInt(strSectionHeader, Key, Default, strFileName)
End Function

