Attribute VB_Name = "Gestion_outil"
'
Sub Rotation_Magasin_outil(Num_Outil As Integer)
Dim I As Integer
Dim inc As Double
Dim inc_visu As Double



    inc = Num_Outil - Machine.MagasinPo.Valeur_axe
    inc_visu = Abs(inc) * 5
    
    For I = 1 To inc_visu
        ' = Magasin
        Machine.MagasinPo.Valeur_axe = Machine.MagasinPo.Valeur_axe + (inc / inc_visu)
        Call TRIPOD_SIMUL_FRM.Pic_Paint
    Next I
    
   Machine.MagasinPo.Valeur_axe = Num_Outil

End Sub

Function Charge_Outil(Num_Outil As Integer) As Boolean
Dim SVG_pos As position
Dim I As Integer
Dim MvtA As Integer
Dim MvtB As Integer
Dim MvtC As Integer
Dim MvtD As Integer
Dim Mvt As String




If Num_Outil = Machine.Outil_Courant Then
   'Rien a faire
    Call MessageLOG_CLS
    Call MessageLOG_Print("Outil Identique !!!!!", 2)
Else

If Num_Outil > UBound(OutilC) Then
   'Rien a faire
    Call MessageLOG_CLS
    Call MessageLOG_Print("Outil inexistant sur Machine courante", 2)
    Charge_Outil = False
    Exit Function
End If

' aucun outil dans le magasin donc ne charge pas l'outil si Num_Outil=0 cas de dchargement
    If OutilC(Num_Outil).Type = 0 And Num_Outil Then
        Call MessageLOG_CLS
        Call MessageLOG_Print("Pas d'outil dans le magasin !!!!!", 2)
        Exit Function
    End If
    
    'Sauvegarde position
    For I = 1 To Machine.NB_axe
        SVG_pos.Join(I) = Machine.Element(I).Valeur_axe
    Next I
     Position_precedente = SVG_pos
     
    ' reinitialise le nombre de mouvement dans la macro de chargement de l'outil
    '   MvtA = Mouvement entre le point d'origine et la position avant le chargement outil
    '          Position d'attente avant rotation magazin outil
    '   MvtB = Mouvement lors du chargement outil
    '   MvtC = Mouvement entre la position de chargement outil et le retour a la position  d'attente
    '   MvtD = Mouvement pour retourner au point d'origine
    MvtA = Val(mfncGetFromIni("Macro_outil", "MvtA", Fichier_Machine))
    MvtB = Val(mfncGetFromIni("Macro_outil", "MvtB", Fichier_Machine))
    MvtC = Val(mfncGetFromIni("Macro_outil", "MvtC", Fichier_Machine))
    MvtD = Val(mfncGetFromIni("Macro_outil", "MvtD", Fichier_Machine))
   
   
    '
    '   MvtA = Mouvement entre le point d'origine et la position avant le chargement outil
    '
    For I = 1 To MvtA
        Mvt = "MvtA" & I
        Call Decode_Mvt(mfncGetFromIni("Macro_outil", Mvt, Fichier_Machine), Position_suivante, SVG_pos)
        Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
        Position_precedente = Position_suivante
    Next I
       
    ' Cas avec un outil deja Charger on doit le decharger
      If Machine.Outil_Courant > 0 Then
         Call Decharge_Outil(SVG_pos)
      End If
    
    ' si T00 alors Dechargement outil
    If Num_Outil > 0 Then
       If Val(TRIPOD_SIMUL_FRM.Magasin) <> Num_Outil Then
          TRIPOD_SIMUL_FRM.Magasin = Num_Outil
        'Call Rotation_Magasin_outil(Num_Outil)
       End If
       '
       '   MvtB = Mouvement lors du chargement outil
       '
        For I = 1 To MvtB
            Mvt = "MvtB" & I
            Call Decode_Mvt(mfncGetFromIni("Macro_outil", Mvt, Fichier_Machine), Position_suivante, SVG_pos)
            Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
            Position_precedente = Position_suivante
        Next I
        '
        Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
        ' Update info machine
        Machine.Outil_Courant = Num_Outil
        
        ' A Modifier pour machine AB
        ' La position pivot depend de la lg outil+ orientation broche
        Debug.Print PositionPivot.Z
        Machine.LG_Outil_Courant = OutilC(Machine.Outil_Courant).LG
        PositionPivot = VecAdd(PositionPivot, Machine.Element(Machine.NB_axe + 1).Vecteur, -OutilC(Machine.Outil_Courant).LG)
        
        '
        '   MvtC = Mouvement entre la position de chargement outil et le retour a la position  d'attente
        '
        For I = 1 To MvtC
            Mvt = "MvtC" & I
            Call Decode_Mvt(mfncGetFromIni("Macro_outil", Mvt, Fichier_Machine), Position_suivante, SVG_pos)
            Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
            Position_precedente = Position_suivante
        Next I
    End If
    
    '
    '   MvtD = Mouvement pour retourner au point d'origine
    '
    Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
    For I = 1 To MvtD
           Mvt = "MvtD" & I
           Call Decode_Mvt(mfncGetFromIni("Macro_outil", Mvt, Fichier_Machine), Position_suivante, SVG_pos)
           Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
           Position_precedente = Position_suivante
    Next I
        
    
    End If
    
    Call GetPoint
    Call Affiche_coord
    Call Sauvegarde_Position
    Position_Actuelle.Coord = Pt0
    
    Charge_Outil = True
End Function
Sub Decharge_Outil(SVG As position)
Dim I As Integer
Dim MvtB As Integer
Dim MvtC As Integer
Dim Mvt As String
MvtB = Val(mfncGetFromIni("Macro_outil", "MvtB", Fichier_Machine))
MvtC = Val(mfncGetFromIni("Macro_outil", "MvtC", Fichier_Machine))


  If Machine.Outil_Courant > 0 And Val(TRIPOD_SIMUL_FRM.Magasin) <> Machine.Outil_Courant Then
     Call Rotation_Magasin_outil(Machine.Outil_Courant)
  End If
  
    For I = 1 To MvtB
        Mvt = "MvtB" & I
        Call Decode_Mvt(mfncGetFromIni("Macro_outil", Mvt, Fichier_Machine), Position_suivante, SVG)
        Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
        Position_precedente = Position_suivante
    Next I

TRIPOD_SIMUL_FRM.Magasin = Machine.Outil_Courant
PositionPivot.Z = PositionPivot.Z + OutilC(Machine.Outil_Courant).LG
Machine.Outil_Courant = 0
Machine.LG_Outil_Courant = 0

    For I = 1 To MvtC
        Mvt = "MvtC" & I
        Call Decode_Mvt(mfncGetFromIni("Macro_outil", Mvt, Fichier_Machine), Position_suivante, SVG)
        Call TRIPOD_SIMUL_FRM.Execute_mouvement(True)
        Position_precedente = Position_suivante
    Next I
End Sub
